SoFrustumCamera(3)

NAME
SoFrustumCamera - The SoFrustumCamera class defines a camera with a generic frustum..

SYNOPSIS

#include <Inventor/nodes/SoFrustumCamera.h>

Inherits SoCamera.

  Public Member Functions
virtual SoType getTypeId (void) const
SoFrustumCamera (void)
virtual void scaleHeight (float scalefactor)
virtual SbViewVolume getViewVolume (float useaspectratio=0.0f) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFFloat left
SoSFFloat right
SoSFFloat top
SoSFFloat bottom

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoFrustumCamera ()
virtual void viewBoundingBox (const SbBox3f &box, float aspect, float slack)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoFrustumCamera class defines a camera with a generic frustum.. The SoFrustumCamera class makes it possible to specify a frustum in the same manner as the OpenGL glFrustum() function. It has four new fields (left, right, top, bottom), and will use SoCamera::nearDistance and SoCamera::farDistance for the two last glFrustum() parameters.

This camera can be useful in applications that require full control over the view frustum, such as in CAVE or other multipipe applications.

Since
    Coin 2.5

Constructor & Destructor Documentation

  SoFrustumCamera::SoFrustumCamera (void)
Constructor.

  SoFrustumCamera::~SoFrustumCamera (void) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoFrustumCamera::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoFrustumCamera::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoCamera.

  const SoFieldData ** SoFrustumCamera::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoFrustumCamera::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoCamera.

  void SoFrustumCamera::scaleHeight (float scalefactor) [virtual]
Sets a scalefactor for the height of the camera viewport. What 'viewport height' means exactly in this context depends on the camera model. See documentation in subclasses.

Implements SoCamera.

  SbViewVolume SoFrustumCamera::getViewVolume (float useaspectratio = 0.0f) const [virtual]
Returns total view volume covered by the camera under the current settings.

This view volume is not adjusted to account for viewport mapping. If you want the same view volume as the one used during rendering, you should use getViewVolume(SbViewportRegion & vp, const SbMatrix & mm), or do something like this:

SbViewVolume vv;
float aspectratio = myviewport.getViewportAspectRatio();
switch (camera->viewportMapping.getValue()) {
case SoCamera::CROP_VIEWPORT_FILL_FRAME:
case SoCamera::CROP_VIEWPORT_LINE_FRAME:
case SoCamera::CROP_VIEWPORT_NO_FRAME:
  vv = camera->getViewVolume(0.0f);
  break;
case SoCamera::ADJUST_CAMERA:
  vv = camera->getViewVolume(aspectratio);
  if (aspectratio < 1.0f) vv.scale(1.0f / aspectratio);
  break;
case SoCamera::LEAVE_ALONE:
  vv = camera->getViewVolume(0.0f);
  break;
default:
  assert(0 && 'unknown viewport mapping');
  break;
}.fi

Also, for the CROPPED viewport mappings, the viewport might be changed if the viewport aspect ratio is not equal to the camera aspect ratio. See the SoCamera::getView() source-code (private method) to see how this is done.

Implements SoCamera.

  void SoFrustumCamera::viewBoundingBox (const SbBox3f & box, float aspect, float slack) [protected], [virtual]
Convenience method for setting up the camera definition to cover the given bounding box with the given aspect ratio. Multiplies the exact dimensions with a slack factor to have some space between the rendered model and the borders of the rendering area.

If you define your own camera node class, be aware that this method should not set the orientation field of the camera, only the position, focal distance and near and far clipping planes.

Implements SoCamera.

Member Data Documentation

  SoSFFloat SoFrustumCamera::left
The left clipping plane position. Default value is -0.5.

  SoSFFloat SoFrustumCamera::right
The right clipping plane position. Default value is 0.5

  SoSFFloat SoFrustumCamera::top
The top clipping plane position. Default value is 0.5.

  SoSFFloat SoFrustumCamera::bottom
The bottom clipping plane position. Default value is -0.5.

Author

Generated automatically by Doxygen for Coin from the source code.